﻿// ColorComboBox40TestDlg.cpp : インプリメンテーション ファイル
//

#include <afxwin.h>
#include "resource.h"
#include "..\\ColorComboBox140\\ColorComboBox140.h"
#include "ColorComboBox140Test.h"
#include "ColorComboBox140TestDlg.h"

#ifdef _DEBUG
//#define new DEBUG_NEW
#endif

#define IDC_COLOR_COMBO_BOX 5678


/////////////////////////////////////////////////////////////////////////////
// CColorComboBox40TestDlg ダイアログ

CColorComboBox140TestDlg::CColorComboBox140TestDlg (CWnd* pParent /*=NULL*/)
	: CDialog (CColorComboBox140TestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CColorComboBox40TestDlg)
		// メモ: この位置に ClassWizard によってメンバの初期化が追加されます。
	//}}AFX_DATA_INIT
	// メモ: LoadIcon は Win32 の DestroyIcon のサブシーケンスを要求しません。
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CColorComboBox140TestDlg::DoDataExchange (CDataExchange* pDX) {
	CDialog::DoDataExchange (pDX);
}

BEGIN_MESSAGE_MAP(CColorComboBox140TestDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CREATE()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CColorComboBox140TestDlg メッセージ ハンドラ

BOOL CColorComboBox140TestDlg::OnInitDialog() {
	CDialog::OnInitDialog();
	
	// このダイアログ用のアイコンを設定します。フレームワークはアプリケーションのメイン
	// ウィンドウがダイアログでない時は自動的に設定しません。
	SetIcon(m_hIcon, TRUE);			// 大きいアイコンを設定
	SetIcon(m_hIcon, FALSE);		// 小さいアイコンを設定
	
	// カラーコンボボックスの位置とサイズ調整
	CRect rcStaticDummy;
	CWnd* pStaticDummy = GetDlgItem (IDC_STATIC_DUMMY);
	pStaticDummy->GetWindowRect (&rcStaticDummy);
	this->ScreenToClient (&rcStaticDummy);
	m_theColorComboBox.MoveWindow (&rcStaticDummy);
	pStaticDummy->DestroyWindow ();
	return TRUE;
}

// もしダイアログボックスに最小化ボタンを追加するならば、アイコンを描画する
// コードを以下に記述する必要があります。MFC アプリケーションは document/view
// モデルを使っているので、この処理はフレームワークにより自動的に処理されます。

void CColorComboBox140TestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // 描画用のデバイス コンテキスト

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// クライアントの矩形領域内の中央
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// アイコンを描画します。
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// システムは、ユーザーが最小化ウィンドウをドラッグしている間、
// カーソルを表示するためにここを呼び出します。
HCURSOR CColorComboBox140TestDlg::OnQueryDragIcon () {
	return (HCURSOR) m_hIcon;
}


int CColorComboBox140TestDlg::OnCreate (LPCREATESTRUCT lpCreateStruct) {
	if (CDialog::OnCreate(lpCreateStruct) == -1) {
		return -1;
	}
	// カラーコンボボックスの作成
	m_theColorComboBox.Create (
		WS_BORDER | WS_VISIBLE | WS_CHILD | WS_TABSTOP | WS_VSCROLL, 
		CRect (10, 10, 300, 300), this, IDC_COLOR_COMBO_BOX);
	// サンプルカラーの追加
	m_theColorComboBox.AddSampleColor (RGB (0, 0, 0));
	m_theColorComboBox.AddSampleColor (RGB (255, 0, 0));
	m_theColorComboBox.AddSampleColor (RGB (0, 255, 0));
	m_theColorComboBox.AddSampleColor (RGB (0, 0, 255));
	m_theColorComboBox.AddSampleColor (RGB (255, 255, 0));
	m_theColorComboBox.AddSampleColor (RGB (0, 255, 255));
	m_theColorComboBox.AddSampleColor (RGB (255, 255, 255));
	m_theColorComboBox.AddSampleColor (COLORCOMBOBOX_OTHER);
	return 0;
}
